import java.awt.*;
 
public interface individual { 

/*lets the individual "process" it's life,
  it needs input every time step and fitness
  returns gets the output every cycle
*/
public void live(input in, fitness fit, int length);

public void live(input in, fitness fit, int length, double toBeat);

/*after a live has been processed the individual
  got assigned a fitness value
*/
public double getFitness();

/*returns the genotype*/
public int[] getGenome();

/*writes the genome to a file in order to restore that individual later*/
public void toFile(String name);

//+++++++++++++++++++++++++++++++++++++++++++++++
//rest is no longer generic but to be implemented
//problem specific:

/*returns a randomly generated individual as needed to start evolution*/
public individual getRandomInd();

/*returns input function */
public input getIn();

/*returns fitness function*/
public fitness getFit();

/*returns lifetime (length for live method)*/
public int getLifetime();

/*returns elitism (number of individuals carried over [copied] to next gen)*/
public int getElitism();

/*returns number of individuals from pop which might be parents*/
public int getCompPool();

/*returns offspring generated from input individuals*/
public individual[] getOffspring(individual[] parents);

}