//PLEASE READ THE README.TXT FILE FIRST!!!

/*
GRN algorithm in an artificial evolution framework to model 
simple differentiation in two cells with the same genome
Copyright (C) 2005  Johannes Knabe
j.f.knabe@herts.ac.uk

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
import java.util.*;
import java.io.*;
import java.util.zip.*;
 
public class main { 

public static String[] split(String what, String delim){
StringTokenizer x=new StringTokenizer(what,delim,true);
Vector y=new Vector();
//String[] ret=new String[x.countTokens()];
int max=x.countTokens();
String t;
int last=-1;
     for(int i=0;i<max;i++) {
         t=x.nextToken();
         if(t.equals(delim)){
           if(last==i-1){
             y.add("");
             }
           last=i;
           }
         else
           y.add(t);
     }
String[] ret=new String[y.size()];
     for(int i=0;i<ret.length;i++) {
         ret[i]=""+y.elementAt(i);
     }
return ret;
}


public static java.util.Random rand=new java.util.Random(230581);
public static String resultsDir;
public static int generations=500;
public static int popSize=250;
public static int minFunc=0;//currently there are 16 functions available,
public static int maxFunc=16;//see getIn() in QuickGRN/KnabeGRN.java for details
public static int startGeneNo=0;
public static boolean slowShift;

public static void runTwoCellSeries(int numberOfGenes,int fitnessMeasure,int func,int rep){
startGeneNo=numberOfGenes;
//KnabeGRN.geneNo=startGeneNo;
resultsDir="results(KnabeGRN"+fitnessMeasure+"FitFunc"+numberOfGenes+"Genes)/";
System.out.print("Doing Population with input func "+func+"; internal number "+rep);
System.out.println(" - best fitness: "+runTwoCellPopulation(func,fitnessMeasure,rep));
System.out.println(" results: see "+resultsDir);
}


public static double runTwoCellPopulation(int whatFunction,int whatMeasure,int internalNo){
int[] genome=new int[KnabeGRN.geneNo*11+39];//12:4 for a cis site + 2 for cis delimiters + 4 for protein produced + 2 for gene delimiters
java.util.Random rand=new java.util.Random();
int next;
for(int i=0;i<genome.length;i++){
  next=rand.nextInt(2);
  //System.out.print(next+",");
  genome[i]=next;
}
for(int i=0;i<KnabeGRN.geneNo;i++){
  genome[i*11+10]=3;
  genome[i*11+4]=2;
}
twoCellGRN z=new twoCellGRN(genome);

KnabeGRN.setInputFunction(whatFunction);
KnabeGRN.setFitFunction(whatMeasure);
File file = null;
PrintWriter out = null;
String currDir=resultsDir+whatFunction+"/"; //e.g. results/0/
try{//make directory (if not already existing...)
  file = new File(currDir);
  file.mkdirs();}
catch(Exception e){}
try{
  file = new File(currDir+internalNo+".txt");
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
twoCellEvo.popSize=popSize;
twoCellEvo test=new twoCellEvo(z);

double bestFit=9999.0;
double currFit=0;
out.println("#Knabe GRN; run number "+internalNo+"; using input function "+whatFunction+"; the start number of genes was "+startGeneNo);
out.println("#generation / fittest");

try{//make directory (if not already existing...)
  File file2 = new File(currDir+internalNo+"/");
  file2.mkdirs();}
catch(Exception e){}

for(int i=0;i<generations;i++){
  test.processGen(i);
  out.print(i+" ");
  z=(twoCellGRN)test.getFittest();
  currFit=z.getFitness();
  out.println(" "+currFit);
  System.out.println(i+" "+currFit);
  z.toFile(currDir+internalNo+"/bestOfGen"+i);//SAVE ALL
  if(currFit<bestFit){//only save if better than last time!
    //z.toFile(currDir+internalNo+"/bestOfGen"+i);//SAVE BETTER
    bestFit=currFit;
    }
  test.nextGen();
}
out.close();
return bestFit;
}


//recursive function to add a direcotry with all sub-directories to zip z
//output format (in the zip) is linux compatible, i.e. with "/" seperating dirs
//while the input might be from windows machines, as might happen in mixed
//condor networks
public static void zip(File x,String Dir,ZipOutputStream z){
try{
if(!x.exists())
  System.err.println("file not found");
if(!x.isDirectory()){
 z.putNextEntry(new ZipEntry((Dir+x.getName()).replace('\\','/')));
 FileInputStream y=new FileInputStream(x);
 byte[] a=new byte[(int)x.length()];
 int did=y.read(a);
 if(did!=x.length())
   System.err.println("DID NOT GET WHOLE FILE "+Dir+x.getName()+" ; only "+ did+ " of "+x.length());
 z.write(a,0,a.length);
 z.closeEntry();
 y.close();
 x=null;
 }
else  //recurse
 {
 String nnn=Dir+x.getName()+File.separator;
 x=null;
 z.putNextEntry(new ZipEntry(nnn.replace('\\','/')));
 z.closeEntry();
 String[] dirlist=(new File(nnn)).list();
 for(int i=0;i<dirlist.length;i++){
   zip(new File(nnn+dirlist[i]),nnn,z);
   }
 }
}catch(Exception e){System.err.println("Error in zip-Method!!"+e);}
}

//only creates the zip and initiates the recursive zipping
//here all folders beginning with "result" are included
public static void zipAll(String name){
try{
File here=new File(".");
String[] dirlist=here.list();
ZipOutputStream z=new ZipOutputStream(new FileOutputStream(name));
for(int i=0;i<dirlist.length;i++)
 if(dirlist[i].startsWith("results"))
  zip(new File("."+File.separator+dirlist[i]),"."+File.separator,z);
z.close();
}catch(Exception e){System.err.println("Error in zipAll-Method!!"+e);}
}


public static void main(String[] args){
// runKnabeSeriesSaveAll(9,1);
  KnabeGRN.geneStartLength=11;
  KnabeGRN.specificNonRandomStart=false;
  KnabeGRN.lifetime=400;
  KnabeGRN.wavelength=20;
  slowShift=true; 

if(slowShift)
  System.out.println("Using slow shifting to make differentiation more gradual!");
else
  System.out.println("Using full shifting to make differentiation immediate!");
if(args.length!=0){
  int func=Integer.parseInt(args[0]);
  runTwoCellSeries(9,0,func/10,func%10);
  runTwoCellSeries(9,1,func/10,func%10);
  if(args.length==1)//only zip results when no additional parameter is given
    zipAll("res"+args[0]+".zip");
}
else{
  System.err.println("Parameter expected; 0 till 40 are valid!");
}

}//end main method

}//end main class